diff --git a/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/UriUtils.java b/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/UriUtils.java
index 6f7b41cd8e..b58da6d3a5 100644
--- a/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/UriUtils.java
+++ b/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/UriUtils.java
@@ -1,9 +1,9 @@
 // $Id$
 /**
 * Copyright (C) 2007 EDIT
-* European Distributed Institute of Taxonomy 
+* European Distributed Institute of Taxonomy
 * http://www.e-taxonomy.eu
-* 
+*
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */
@@ -24,8 +24,10 @@ import java.util.ArrayList;
 import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
+import java.util.Map.Entry;
 
 import org.apache.http.Header;
+import org.apache.http.HttpEntity;
 import org.apache.http.HttpException;
 import org.apache.http.HttpResponse;
 import org.apache.http.HttpStatus;
@@ -35,8 +37,9 @@ import org.apache.http.client.ClientProtocolException;
 import org.apache.http.client.HttpClient;
 import org.apache.http.client.methods.HttpGet;
 import org.apache.http.client.methods.HttpHead;
+import org.apache.http.client.methods.HttpPost;
 import org.apache.http.client.methods.HttpUriRequest;
-import org.apache.http.client.utils.URIUtils;
+import org.apache.http.client.utils.URIBuilder;
 import org.apache.http.client.utils.URLEncodedUtils;
 import org.apache.http.impl.client.DefaultHttpClient;
 import org.apache.log4j.Logger;
@@ -48,10 +51,15 @@ import org.apache.log4j.Logger;
  */
 public class UriUtils {
 	private static final Logger logger = Logger.getLogger(UriUtils.class);
-		
+
+	public enum HttpMethod{
+	    GET,
+	    POST
+	}
+
 	/**
 	 * see {@link #getInputStream(URI, Map)}
-	 * 
+	 *
 	 * @param uri
 	 * @return
 	 * @throws IOException
@@ -60,21 +68,21 @@ public class UriUtils {
 	public static InputStream getInputStream(URI uri) throws IOException, HttpException{
 		return getInputStream(uri, null);
 	}
-	
+
 	/**
 	 * Retrieves an {@link InputStream input stream} of the resource located at the given uri.
-	 * 
+	 *
 	 * @param uri
 	 * @return
 	 * @throws IOException
-	 * @throws HttpException 
+	 * @throws HttpException
 	 */
 	public static InputStream getInputStream(URI uri, Map<String, String> requestHeaders) throws IOException, HttpException{
-		
+
 		if(requestHeaders == null){
 			requestHeaders = new HashMap<String, String>();
 		}
-		
+
 		if (uri.getScheme().equals("http") || uri.getScheme().equals("https")){
 			HttpResponse response = UriUtils.getResponse(uri, requestHeaders);
 			if(UriUtils.isOk(response)){
@@ -87,17 +95,17 @@ public class UriUtils {
 			File file = new File(uri);
 			return new FileInputStream(file);
 		}else{
-			throw new RuntimeException("Protocol not handled yet: " + uri.getScheme()); 
+			throw new RuntimeException("Protocol not handled yet: " + uri.getScheme());
 		}
 	}
-	
+
 	/**
-	 * Retrieves the size of the resource defined by the given uri in bytes 
-	 * 
+	 * Retrieves the size of the resource defined by the given uri in bytes
+	 *
 	 * @param uri the resource
 	 * @param requestHeaders additional headers. May be <code>null</code>
 	 * @return the size of the resource in bytes
-	 * 
+	 *
 	 * @throws ClientProtocolException
 	 * @throws IOException
 	 * @throws HttpException
@@ -106,25 +114,25 @@ public class UriUtils {
 		if(requestHeaders == null){
 			requestHeaders = new HashMap<String, String>();
 		}
-		
+
 		if (uri.getScheme().equals("http") || uri.getScheme().equals("https")){
 			HttpResponse response = UriUtils.getResponse(uri, requestHeaders);
 			if(UriUtils.isOk(response)){
 	        	Header[] contentLengths = response.getHeaders("Content-Length");
-	        	
+
 	        	if(contentLengths == null || contentLengths.length == 0){
 	        		throw new HttpException("Could not retrieve Content-Length");
 	        	}
-	        	
+
 	        	if(contentLengths.length > 1){
 	        		throw new HttpException("Multiple Conten-Length headers sent");
 	        	}
-	        	
+
 	        	Header contentLength = contentLengths[0];
 	        	String value = contentLength.getValue();
-	        	
+
 	        	return Long.valueOf(value);
-	        	
+
 	        } else {
 	        	throw new HttpException("HTTP Reponse code is not = 200 (OK): " + UriUtils.getStatus(response));
 	        }
@@ -132,21 +140,21 @@ public class UriUtils {
 			File file = new File(uri);
 			return file.length();
 		}else{
-			throw new RuntimeException("Protocol not handled yet: " + uri.getScheme()); 
+			throw new RuntimeException("Protocol not handled yet: " + uri.getScheme());
 		}
 	}
-	
+
 	/**
-	 * 
+	 *
 	 * @param response
 	 * @return
 	 */
 	public static boolean isOk(HttpResponse response){
 		return response.getStatusLine().getStatusCode() == HttpStatus.SC_OK;
 	}
-	
+
 	/**
-	 * 
+	 *
 	 * @param response
 	 * @return
 	 * @throws IOException
@@ -154,45 +162,85 @@ public class UriUtils {
 	public static InputStream getContent(HttpResponse response) throws IOException{
 		return response.getEntity().getContent();
 	}
-	
+
 	public static String getStatus(HttpResponse response){
 		StatusLine statusLine = response.getStatusLine();
 		return "(" + statusLine.getStatusCode() + ")" + statusLine.getReasonPhrase();
 	}
-	
-	/**
-	 * Returns a {@link HttpResponse} object for given uri
-	 * 
-	 * @param uri
-	 * @param requestHeaders
-	 * @return
-	 * @throws ClientProtocolException
-	 * @throws IOException
-	 */
+
+    /**
+     * Sends a HTTP GET request to the defined URI and returns the {@link HttpResponse}.
+     * @param uri the URI of this HTTP request
+     * @param requestHeaders the parameters of the connection
+     * @return the {@link HttpResponse} of the request
+     * @throws IOException
+     * @throws ClientProtocolException
+     */
 	public static HttpResponse getResponse(URI uri, Map<String, String> requestHeaders) throws ClientProtocolException, IOException{
-		// Create an instance of HttpClient.
-		HttpClient  client = new DefaultHttpClient();
-		
-		HttpGet  method = new HttpGet(uri);
-	    
-        // configure the connection
-        if(requestHeaders != null){
-	       	for(String key : requestHeaders.keySet()){
-	        	method.addHeader(key, requestHeaders.get(key));        	
-	        }
-		}
-        
-		//TODO  method.setFollowRedirects(followRedirects);
+		return getResponseByType(uri, requestHeaders, HttpMethod.GET, null);
+	}
 
-        logger.debug("sending GET request: " + uri);
-        
-        return client.execute(method);
+    /**
+     * Sends a HTTP POST request to the defined URI and returns the {@link HttpResponse}.
+     * @param uri the URI of this HTTP request
+     * @param requestHeaders the parameters of the connection
+     * @param entity the {@link HttpEntity} that should be attached to this request
+     * @return the {@link HttpResponse} of the request
+     * @throws IOException
+     * @throws ClientProtocolException
+     */
+	public static HttpResponse getPostResponse(URI uri, Map<String, String> requestHeaders, HttpEntity entity) throws ClientProtocolException, IOException{
+	    return getResponseByType(uri, requestHeaders, HttpMethod.POST, entity);
 	}
-	
+
+    /**
+     * Sends a HTTP request of the given {@link HttpMethod} to the defined URI and returns the {@link HttpResponse}.
+     * @param uri the URI of this HTTP request
+     * @param requestHeaders the parameters of the connection
+     * @param httpMethod defines if method is POST or GET
+     * @return the {@link HttpResponse} of the request
+     * @throws IOException
+     * @throws ClientProtocolException
+     */
+    public static HttpResponse getResponseByType(URI uri, Map<String, String> requestHeaders, HttpMethod httpMethod, HttpEntity entity) throws IOException, ClientProtocolException {
+        // Create an instance of HttpClient.
+	    HttpClient  client = new DefaultHttpClient();
+
+	    HttpUriRequest method;
+	    switch (httpMethod) {
+        case GET:
+            method = new HttpGet(uri);
+            break;
+        case POST:
+            HttpPost httpPost = new HttpPost(uri);
+            if(entity!=null){
+                httpPost.setEntity(entity);
+            }
+            method = httpPost;
+            break;
+        default:
+            method = new HttpPost(uri);
+            break;
+        }
+
+	    // configure the connection
+	    if(requestHeaders != null){
+	        for(Entry<String, String> e : requestHeaders.entrySet()){
+	            method.addHeader(e.getKey(), e.getValue());
+	        }
+	    }
+
+	    //TODO  method.setFollowRedirects(followRedirects);
+
+	    logger.debug("sending "+httpMethod+" request: " + uri);
+
+	    return client.execute(method);
+    }
+
 	public static URI createUri(URL baseUrl, String subPath, List<NameValuePair> qparams, String fragment) throws	URISyntaxException {
-		
+
 		String path = baseUrl.getPath();
-		
+
 		if(subPath != null){
 			if(!path.endsWith("/")){
 				path += "/";
@@ -202,7 +250,7 @@ public class UriUtils {
 			}
 			path += subPath;
 		}
-		
+
 		if(qparams == null){
 			qparams = new ArrayList<NameValuePair>(0);
 		}
@@ -210,16 +258,20 @@ public class UriUtils {
 		if(! qparams.isEmpty()){
 			query = URLEncodedUtils.format(qparams, "UTF-8");
 		}
-		
-		URI uri = URIUtils.createURI(baseUrl.getProtocol(),
-				baseUrl.getHost(), baseUrl.getPort(), path, query, fragment);
 
-		return uri;
+		URIBuilder uriBuilder = new URIBuilder();
+		uriBuilder.setScheme(baseUrl.getProtocol());
+		uriBuilder.setHost(baseUrl.getHost());
+		uriBuilder.setPort(baseUrl.getPort());
+		uriBuilder.setPath(path);
+		uriBuilder.setQuery(query);
+		uriBuilder.setFragment(fragment);
+		return uriBuilder.build();
 	}
-	
+
 	/**
 	 * Tests internet connectivity by testing HEAD request for 4 known URL's.<BR>
-	 * If non of them is available <code>false</code> is returned. Otherwise true.<BR> 
+	 * If non of them is available <code>false</code> is returned. Otherwise true.<BR>
 	 * @param firstUriToTest if not <code>null</code> this URI is tested before testing the standard URLs.
 	 * @return true if internetconnectivity is given.
 	 */
@@ -228,7 +280,7 @@ public class UriUtils {
 		if (firstUriToTest != null && isServiceAvailable(firstUriToTest)){
 			return true;
 		}
-		
+
 		URI uri = URI.create("http://www.cnn.com/");
 		if (isServiceAvailable(uri)){
 			return true;
@@ -245,10 +297,10 @@ public class UriUtils {
 		if (isServiceAvailable(uri)){
 			return true;
 		}
-		
+
 		return result;
 	}
-	
+
 	/**
 	 * Performs HEAD request for the given URI.<BR>
 	 * If any exception occurs <code>false</code> is returned. Otherwise true. <BR>
@@ -257,11 +309,11 @@ public class UriUtils {
 	 */
 	public static boolean isServiceAvailable(URI serviceUri){
 		boolean result = false;
-		
-        //Http 
+
+        //Http
 		HttpClient  client = new DefaultHttpClient();
 		HttpUriRequest request = new HttpHead(serviceUri);
-		 
+
 		try {
 			// Execute the request
 			HttpResponse response = client.execute(request);
@@ -270,7 +322,7 @@ public class UriUtils {
 				logger.debug(response.getStatusLine());
 			}
 			 result = true;
-			 
+
 		} catch (UnknownHostException e1) {
 			logger.info("Unknwon Host: " +e1.getMessage());
 		} catch (ClientProtocolException e2) {
@@ -278,19 +330,19 @@ public class UriUtils {
 		} catch (IOException e3) {
 			logger.info("IOException: " + e3.getMessage());
 		}
-	     
-	     // When HttpClient instance is no longer needed, 
+
+	     // When HttpClient instance is no longer needed,
 	     // shut down the connection manager to ensure
 	     // immediate deallocation of all system resources
 		//needed ?
-//	     client.getConnectionManager().shutdown();   
+//	     client.getConnectionManager().shutdown();
 
 		return result;
 	}
-	
+
 	/**
 	 * Tests reachability of a root server by trying to resolve a host name.
-	 * @param hostNameToResolve the host name to resolve. If <code>null</code> 
+	 * @param hostNameToResolve the host name to resolve. If <code>null</code>
 	 * a default host name is tested.
 	 * @return
 	 */
@@ -307,7 +359,7 @@ public class UriUtils {
 		     return false;
 		 }
 	}
-	
+
 	//from http://www.javabeginners.de/Netzwerk/File_zu_URL.php
 	public static URL fileToURL(File file){
         URL url = null;
@@ -320,9 +372,9 @@ public class UriUtils {
             e.printStackTrace();
         }
         return url;
-    } 
-	
-	//from http://blogs.sphinx.at/java/erzeugen-von-javaiofile-aus-javaneturl/	
+    }
+
+	//from http://blogs.sphinx.at/java/erzeugen-von-javaiofile-aus-javaneturl/
 	public static File urlToFile(URL url) {
         URI uri;
         try {
diff --git a/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/UrlUtf8Coder.java b/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/UrlUtf8Coder.java
new file mode 100644
index 0000000000..783d156065
--- /dev/null
+++ b/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/UrlUtf8Coder.java
@@ -0,0 +1,189 @@
+/**
+ * Provides a method to encode any string into a URL-safe
+ * form.
+ * Non-ASCII characters are first encoded as sequences of
+ * two or three bytes, using the UTF-8 algorithm, before being
+ * encoded as %HH escapes.
+ *
+ * Created: 17 April 1997
+ * Author: Bert Bos <bert@w3.org>
+ *
+ * URLUTF8Encoder: http://www.w3.org/International/URLUTF8Encoder.java
+ *
+ * Copyright © 1997 World Wide Web Consortium, (Massachusetts
+ * Institute of Technology, European Research Consortium for
+ * Informatics and Mathematics, Keio University). All Rights Reserved. 
+ * This work is distributed under the W3C® Software License [1] in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY; without even
+ * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+ * PURPOSE.
+ *
+ * [1] http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
+ */
+package eu.etaxonomy.cdm.common;
+
+public class UrlUtf8Coder{
+
+  final static String[] hex = {
+    "%00", "%01", "%02", "%03", "%04", "%05", "%06", "%07",
+    "%08", "%09", "%0a", "%0b", "%0c", "%0d", "%0e", "%0f",
+    "%10", "%11", "%12", "%13", "%14", "%15", "%16", "%17",
+    "%18", "%19", "%1a", "%1b", "%1c", "%1d", "%1e", "%1f",
+    "%20", "%21", "%22", "%23", "%24", "%25", "%26", "%27",
+    "%28", "%29", "%2a", "%2b", "%2c", "%2d", "%2e", "%2f",
+    "%30", "%31", "%32", "%33", "%34", "%35", "%36", "%37",
+    "%38", "%39", "%3a", "%3b", "%3c", "%3d", "%3e", "%3f",
+    "%40", "%41", "%42", "%43", "%44", "%45", "%46", "%47",
+    "%48", "%49", "%4a", "%4b", "%4c", "%4d", "%4e", "%4f",
+    "%50", "%51", "%52", "%53", "%54", "%55", "%56", "%57",
+    "%58", "%59", "%5a", "%5b", "%5c", "%5d", "%5e", "%5f",
+    "%60", "%61", "%62", "%63", "%64", "%65", "%66", "%67",
+    "%68", "%69", "%6a", "%6b", "%6c", "%6d", "%6e", "%6f",
+    "%70", "%71", "%72", "%73", "%74", "%75", "%76", "%77",
+    "%78", "%79", "%7a", "%7b", "%7c", "%7d", "%7e", "%7f",
+    "%80", "%81", "%82", "%83", "%84", "%85", "%86", "%87",
+    "%88", "%89", "%8a", "%8b", "%8c", "%8d", "%8e", "%8f",
+    "%90", "%91", "%92", "%93", "%94", "%95", "%96", "%97",
+    "%98", "%99", "%9a", "%9b", "%9c", "%9d", "%9e", "%9f",
+    "%a0", "%a1", "%a2", "%a3", "%a4", "%a5", "%a6", "%a7",
+    "%a8", "%a9", "%aa", "%ab", "%ac", "%ad", "%ae", "%af",
+    "%b0", "%b1", "%b2", "%b3", "%b4", "%b5", "%b6", "%b7",
+    "%b8", "%b9", "%ba", "%bb", "%bc", "%bd", "%be", "%bf",
+    "%c0", "%c1", "%c2", "%c3", "%c4", "%c5", "%c6", "%c7",
+    "%c8", "%c9", "%ca", "%cb", "%cc", "%cd", "%ce", "%cf",
+    "%d0", "%d1", "%d2", "%d3", "%d4", "%d5", "%d6", "%d7",
+    "%d8", "%d9", "%da", "%db", "%dc", "%dd", "%de", "%df",
+    "%e0", "%e1", "%e2", "%e3", "%e4", "%e5", "%e6", "%e7",
+    "%e8", "%e9", "%ea", "%eb", "%ec", "%ed", "%ee", "%ef",
+    "%f0", "%f1", "%f2", "%f3", "%f4", "%f5", "%f6", "%f7",
+    "%f8", "%f9", "%fa", "%fb", "%fc", "%fd", "%fe", "%ff"
+  };
+
+  /**
+   * Encode a string to the "x-www-form-urlencoded" form, enhanced
+   * with the UTF-8-in-URL proposal. This is what happens:
+   *
+   * <ul>
+   * <li><p>The ASCII characters 'a' through 'z', 'A' through 'Z',
+   *        and '0' through '9' remain the same.
+   *
+   * <li><p>The unreserved characters - _ . ! ~ * ' ( ) remain the same.
+   *
+   * <li><p>The space character ' ' is converted into a plus sign '+'.
+   *
+   * <li><p>All other ASCII characters are converted into the
+   *        3-character string "%xy", where xy is
+   *        the two-digit hexadecimal representation of the character
+   *        code
+   *
+   * <li><p>All non-ASCII characters are encoded in two steps: first
+   *        to a sequence of 2 or 3 bytes, using the UTF-8 algorithm;
+   *        secondly each of these bytes is encoded as "%xx".
+   * </ul>
+   *
+   * @param s The string to be encoded
+   * @return The encoded string
+   */
+  public static String encode(String s)
+  {
+    StringBuffer sbuf = new StringBuffer();
+    int len = s.length();
+    for (int i = 0; i < len; i++) {
+      int ch = s.charAt(i);
+      if ('A' <= ch && ch <= 'Z') {		// 'A'..'Z'
+        sbuf.append((char)ch);
+      } else if ('a' <= ch && ch <= 'z') {	// 'a'..'z'
+	       sbuf.append((char)ch);
+      } else if ('0' <= ch && ch <= '9') {	// '0'..'9'
+	       sbuf.append((char)ch);
+      } else if (ch == ' ') {			// space
+	       sbuf.append(hex[ch]);     //Note: changed from + to %20 for use according to http://www.doi.org/doi_handbook/2_Numbering.html#2.5.2.4
+      } else if (ch == '-' || ch == '_'		// unreserved
+          || ch == '.' || ch == '!'
+          || ch == '~' || ch == '*'
+          || ch == '\'' || ch == '('
+          || ch == ')') {
+        sbuf.append((char)ch);
+      } else if (ch <= 0x007f) {		// other ASCII
+	       sbuf.append(hex[ch]);
+      } else if (ch <= 0x07FF) {		// non-ASCII <= 0x7FF
+	       sbuf.append(hex[0xc0 | (ch >> 6)]);
+	       sbuf.append(hex[0x80 | (ch & 0x3F)]);
+      } else {					// 0x7FF < ch <= 0xFFFF
+	       sbuf.append(hex[0xe0 | (ch >> 12)]);
+	       sbuf.append(hex[0x80 | ((ch >> 6) & 0x3F)]);
+	       sbuf.append(hex[0x80 | (ch & 0x3F)]);
+      }
+    }
+    return sbuf.toString();
+  }
+  
+	/*
+	 * Created: 17 April 1997
+	 * Author: Bert Bos <bert@w3.org>
+	 *
+	 * unescape: http://www.w3.org/International/unescape.java
+	 *
+	 * Copyright © 1997 World Wide Web Consortium, (Massachusetts
+	 * Institute of Technology, European Research Consortium for
+	 * Informatics and Mathematics, Keio University). All Rights Reserved. 
+	 * This work is distributed under the W3C® Software License [1] in the
+	 * hope that it will be useful, but WITHOUT ANY WARRANTY; without even
+	 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+	 * PURPOSE.
+	 *
+	 * [1] http://www.w3.org/Consortium/Legal/2002/copyright-software-20021231
+	 */
+  public static String unescape(String s) {
+	    StringBuffer sbuf = new StringBuffer () ;
+	    int l  = s.length() ;
+	    int ch = -1 ;
+	    int b, sumb = 0;
+	    for (int i = 0, more = -1 ; i < l ; i++) {
+	      /* Get next byte b from URL segment s */
+	      switch (ch = s.charAt(i)) {
+		case '%':
+		  ch = s.charAt (++i) ;
+		  int hb = (Character.isDigit ((char) ch) 
+			    ? ch - '0'
+			    : 10+Character.toLowerCase((char) ch) - 'a') & 0xF ;
+		  ch = s.charAt (++i) ;
+		  int lb = (Character.isDigit ((char) ch)
+			    ? ch - '0'
+			    : 10+Character.toLowerCase ((char) ch)-'a') & 0xF ;
+		  b = (hb << 4) | lb ;
+		  break ;
+		case '+':
+		  b = ' ' ;
+		  break ;
+		default:
+		  b = ch ;
+	      }
+	      /* Decode byte b as UTF-8, sumb collects incomplete chars */
+	      if ((b & 0xc0) == 0x80) {			// 10xxxxxx (continuation byte)
+		sumb = (sumb << 6) | (b & 0x3f) ;	// Add 6 bits to sumb
+		if (--more == 0) sbuf.append((char) sumb) ; // Add char to sbuf
+	      } else if ((b & 0x80) == 0x00) {		// 0xxxxxxx (yields 7 bits)
+		sbuf.append((char) b) ;			// Store in sbuf
+	      } else if ((b & 0xe0) == 0xc0) {		// 110xxxxx (yields 5 bits)
+		sumb = b & 0x1f;
+		more = 1;				// Expect 1 more byte
+	      } else if ((b & 0xf0) == 0xe0) {		// 1110xxxx (yields 4 bits)
+		sumb = b & 0x0f;
+		more = 2;				// Expect 2 more bytes
+	      } else if ((b & 0xf8) == 0xf0) {		// 11110xxx (yields 3 bits)
+		sumb = b & 0x07;
+		more = 3;				// Expect 3 more bytes
+	      } else if ((b & 0xfc) == 0xf8) {		// 111110xx (yields 2 bits)
+		sumb = b & 0x03;
+		more = 4;				// Expect 4 more bytes
+	      } else /*if ((b & 0xfe) == 0xfc)*/ {	// 1111110x (yields 1 bit)
+		sumb = b & 0x01;
+		more = 5;				// Expect 5 more bytes
+	      }
+	      /* We don't test if the UTF-8 encoding is well-formed */
+	    }
+	    return sbuf.toString() ;
+	  }
+
+}
diff --git a/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/monitor/ProgressMonitorWrapper.java b/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/monitor/ProgressMonitorWrapper.java
index 349eeee81d..4edb553681 100644
--- a/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/monitor/ProgressMonitorWrapper.java
+++ b/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/monitor/ProgressMonitorWrapper.java
@@ -90,7 +90,11 @@ public abstract class ProgressMonitorWrapper implements
      * This implementation of a <code>IProgressMonitor</code>
      * method forwards to the wrapped progress monitor.
      * Clients may override this method to do additional
-     * processing.
+     * processing.<BR>
+     * As the  {@link IProgressMonitor interface} documentation for 
+     * {@link IProgressMonitor#internalWorked(double) this method} 
+     * says the method must not be called by a client. 
+     * Clients should always use the method </code>worked(int)</code>.
      *
      * @see IProgressMonitor#internalWorked(double)
      */
diff --git a/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/monitor/SubProgressMonitor.java b/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/monitor/SubProgressMonitor.java
index fccaf17dc4..a6f3bd16d0 100644
--- a/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/monitor/SubProgressMonitor.java
+++ b/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/monitor/SubProgressMonitor.java
@@ -147,9 +147,11 @@ public class SubProgressMonitor extends ProgressMonitorWrapper {
         sentToParent = 0;
     }
 
-    /* (Intentionally not javadoc'd)
-     * Implements the internal method <code>IProgressMonitor.internalWorked</code>.
+
+    /* (non-Javadoc)
+     * @see eu.etaxonomy.cdm.common.monitor.ProgressMonitorWrapper#internalWorked(double)
      */
+    @Override
     public void internalWorked(double work) {
         if (usedUp || nestedBeginTasks != 1) {
             return;
diff --git a/cdmlib-commons/src/test/java/eu/etaxonomy/cdm/common/DoiTest.java b/cdmlib-commons/src/test/java/eu/etaxonomy/cdm/common/DoiTest.java
new file mode 100644
index 0000000000..ff7bfef7d6
--- /dev/null
+++ b/cdmlib-commons/src/test/java/eu/etaxonomy/cdm/common/DoiTest.java
@@ -0,0 +1,151 @@
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.common;
+
+import org.junit.Assert;
+import org.junit.Before;
+import org.junit.Test;
+
+/**
+ * 
+ * Test class for testing the {@link DOI} class.
+ * 
+ * For doi syntax see also http://www.doi.org/doi_handbook/2_Numbering.html
+ * or
+ * http://stackoverflow.com/questions/27910/finding-a-doi-in-a-document-or-page  
+ * 
+ * @author a.mueller
+ *
+ */
+public class DoiTest {
+
+	/**
+	 * @throws java.lang.Exception
+	 */
+	@Before
+	public void setUp() throws Exception {
+	}
+
+	@Test
+	public void testValidParser() {
+		String validDoi = "10.1002/1234";
+		DOI doi = DOI.fromString(validDoi);
+		Assert.assertEquals("10.1002", doi.getPrefix());
+		Assert.assertEquals("1234", doi.getSuffix());
+		
+		validDoi = "10.1002/(SICI)1522-2594(199911)42:5<952::AID-MRM16>3.0.CO;2-S";
+		doi = DOI.fromString(validDoi);
+		Assert.assertEquals("10.1002", doi.getPrefix());
+		Assert.assertEquals("(SICI)1522-2594(199911)42:5<952::AID-MRM16>3.0.CO;2-S", doi.getSuffix());
+		
+		validDoi = "10.1007.10/978-3-642-28108-2_19";
+		doi = DOI.fromString(validDoi);
+		Assert.assertEquals("10.1007.10", doi.getPrefix());
+		Assert.assertEquals("978-3-642-28108-2_19", doi.getSuffix());
+		
+		validDoi="10.1579/0044-7447(2006)35\\[89:RDUICP\\]2.0.CO;2";
+		doi = DOI.fromString(validDoi);
+		Assert.assertEquals("10.1579", doi.getPrefix());
+		Assert.assertEquals("0044-7447(2006)35\\[89:RDUICP\\]2.0.CO;2", doi.getSuffix());
+
+	}
+	
+	@Test
+	public void testFromRegistrantCodeAndSuffix() {
+		DOI doi = DOI.fromRegistrantCodeAndSuffix("1579", "978-3-642-28108-2_19");
+		Assert.assertEquals("10.1579", doi.getPrefix());
+		Assert.assertEquals("978-3-642-28108-2_19", doi.getSuffix());
+		Assert.assertNotEquals("1234", doi.getSuffix());
+	}
+	
+	@Test
+	public void testParserFail() {
+		String invalidDoi = "10.4515260,51.1656910";  //must never match to avoid matches with geo coordinates
+		testInvalid(invalidDoi);
+		invalidDoi = "4210.1000/123456";  //directoryIndicator must always be 10
+		testInvalid(invalidDoi);
+		invalidDoi = "10.1002/12\u0004345";  //control characters (here U+0004) must fail
+		testInvalid(invalidDoi);
+		invalidDoi = "10.1a02/12345";  //registrant code must include only number and dots (to separate sub codes)
+		testInvalid(invalidDoi);
+		invalidDoi = "10.1002:12345";  //column separator is only allowed (+required) in URNs
+		testInvalid(invalidDoi);
+		invalidDoi = "10.1002/";  //doi must always have a suffix length > 0 (if this should changed in future, please do adapt equals and hashCode)
+		testInvalid(invalidDoi);
+		invalidDoi = "10./1234";  //doi must always have a registrant prefix length > 0 (if this should changed in future, please do adapt equals and hashCode)
+		testInvalid(invalidDoi);
+	}
+
+	@Test
+	public void testParserWithPrefixes() {
+		String validDoi = "DOI: 10.1002/1234";
+		DOI doi = DOI.fromString(validDoi);
+		Assert.assertEquals("10.1002", doi.getPrefix());
+		Assert.assertEquals("1234", doi.getSuffix());
+		
+		validDoi = "http://doi.org/10.1002/1234";
+		doi = DOI.fromString(validDoi);
+		Assert.assertEquals("10.1002", doi.getPrefix());
+		Assert.assertEquals("1234", doi.getSuffix());
+	
+		
+		validDoi = "http://doi.org/urn:doi:10.123:456ABC%2Fzyz";
+		doi = DOI.fromString(validDoi);
+		Assert.assertEquals("10.123", doi.getPrefix());
+		Assert.assertEquals("456ABC/zyz", doi.getSuffix());  //urn must be percentage encoded ( / -> %2F)
+		
+	}
+	
+	@Test
+	public void testEquals() {
+		String validDoi = "10.1002/12a4";
+		DOI doi1 = DOI.fromString(validDoi);
+		validDoi = "10.1002/12A4";
+		DOI doi2 = DOI.fromString(validDoi);
+		Assert.assertEquals("DOIs must be equal case insensitive", doi1, doi2);
+		validDoi = "10.1002/12b4";
+		DOI doi3 = DOI.fromString(validDoi);
+		Assert.assertNotEquals("Different DOIs must not be equal", doi1, doi3);
+	}
+	
+	@Test
+	public void testAsURI() {
+		//mandatory encoding according to http://www.doi.org/doi_handbook/2_Numbering.html#2.5.2.4
+		String validDoi = "10.1002/1234%56\"78#90 12?34";
+		DOI doi1 = DOI.fromString(validDoi);
+		String uri = doi1.asURI();
+		Assert.assertEquals(DOI.HTTP_DOI_ORG + "10.1002/1234%2556%2278%2390%2012%3f34", uri);
+		
+		//recommendedEncoding
+		validDoi = "10.1002/1234<56>78{90}12^34";
+		doi1 = DOI.fromString(validDoi);
+		uri = doi1.asURI();
+		Assert.assertEquals(DOI.HTTP_DOI_ORG + "10.1002/1234%3c56%3e78%7b90%7d12%5e34", uri);
+		
+		//recommendedEncoding (cont.)
+		validDoi = "10.1002/1234[56]78`90|12\\34+56";
+		doi1 = DOI.fromString(validDoi);
+		uri = doi1.asURI();
+		Assert.assertEquals(DOI.HTTP_DOI_ORG + "10.1002/1234%5b56%5d78%6090%7c12%5c34%2b56", uri);
+		
+	}
+
+	
+
+	
+	private void testInvalid(String invalidDoi) {
+		try {
+			DOI.fromString(invalidDoi);
+			Assert.fail("DOI should not be parsable: " + invalidDoi);
+		} catch (IllegalArgumentException e) {
+			//OK
+		}
+	}		
+
+}
diff --git a/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/bci/BciSchemaAdapter.java b/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/bci/BciSchemaAdapter.java
index bef88648b1..5a16755327 100644
--- a/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/bci/BciSchemaAdapter.java
+++ b/cdmlib-ext/src/main/java/eu/etaxonomy/cdm/ext/bci/BciSchemaAdapter.java
@@ -30,6 +30,7 @@ import eu.etaxonomy.cdm.model.agent.TeamOrPersonBase;
 import eu.etaxonomy.cdm.model.common.TimePeriod;
 import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.cdm.model.reference.ReferenceFactory;
+import eu.etaxonomy.cdm.strategy.parser.TimePeriodParser;
 
 
 
@@ -167,7 +168,7 @@ public class BciSchemaAdapter extends SchemaAdapterBase<Reference>{
 					reference.setTitleCache(text, true);
 				}
 				if(dcFieldName.equals(DC_DATE)){
-					reference.setDatePublished(TimePeriod.parseString(text));
+					reference.setDatePublished(TimePeriodParser.parseString(text));
 				}
 				if(dcFieldName.equals(DC_PUBLISHER)){
 					reference.setPublisher(text);
